<template>
  <q-layout view="lHh LpR fFr">
    <q-header>
      <div class="top-bar">
        <div class="top-bar-content">
          <img
            src="/statics/images/logo-color-positive.svg"
            alt
            class="webby-logo"
          />
          <div
            class="top-bar-search"
            :style="$q.screen.xs ? 'width: 100%;' : ''"
          >
            <div class="top-bar-search-left">
              <img
                src="/statics/images/search.svg"
                height="24px"
                class="search-icon"
              />
            </div>
            <input
              type="search"
              id="search"
              placeholder="Search Webby"
              style="border: none; flex-grow: 2;"
              @input="setSearchTerm"
              @click:clear="$nextTick(() => clearSearch)"
            />
            <div class="avatar-right-margin">
              <q-btn flat round>
                <img
                  height="28px"
                  :src="userAvatar"
                  style="border-radius: 50%;"
                />
                <q-menu :offset="[70, -5]">
                  <q-list style="min-width: 100px;">
                    <!-- <q-item clickable v-close-popup>
                      <q-item-section>Export Data</q-item-section>
                    </q-item>-->
                    <!-- <q-item clickable v-close-popup @click="toggleDarkMode">
                      <q-item-section>Dark Mode</q-item-section>
                    </q-item>-->
                    <!-- <q-separator /> -->
                    <q-item
                      clickable
                      v-close-popup
                      @click="signIn"
                      v-if="!user.authenticated"
                    >
                      <q-item-section>Sign In</q-item-section>
                    </q-item>
                    <q-item v-else clickable v-close-popup @click="signOut">
                      <q-item-section>Sign Out</q-item-section>
                    </q-item>
                  </q-list>
                </q-menu>
              </q-btn>
            </div>
          </div>
        </div>
      </div>
    </q-header>
    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { mapActions, mapState } from "vuex";
import { userSession, blockstack } from "boot/blockstack";
import { showBlockstackConnect } from "@blockstack/connect";

export default {
  name: "MyLayout",
  data() {
    return {
      leftDrawerOpen: true,
      tab: "dapps",
      dialog: false,
      userAvatar: "/statics/images/avatarrghh.svg",
      userName: "Unnamed User"
    };
  },
  computed: {
    ...mapState(["user"])
    // avatar () {
    //   if (this.user.avatar === null) return "/statics/images/avatarrghh.svg";
    //   else return this.user.avatar;
    // }
  },
  methods: {
    ...mapActions({
      setSearchTerm: "setSearchTerm",
      setUser: "setUser",
      init: "init"
    }),
    toggleDarkMode() {
      this.$q.dark.set(!this.$q.dark.mode);
    },
    signIn() {
      const authOptions = {
        appDetails: {
          name: "Webby",
          icon: "https://heywebby.app/statics/app-logo-128x128.png"
        },
        manifestPath: "/manifest.json",
        finished: async ({ userSession }) => {
          const userData = userSession.loadUserData();
          const profile = await blockstack.lookupProfile(userData.username);

          if (profile.hasOwnProperty("image")) {
            this.userAvatar = profile.image[0].contentUrl;
          }
          if (profile.hasOwnProperty("name")) {
            this.userName = profile.name;
          } else {
            this.userName = userData.decentralizedID;
          }

          const update = {
            id: userData.username,
            name: this.userName,
            avatar: this.userAvatar,
            authenticated: true
          };
          // this.setUser(user);
          this.setUser(update);
          userSession.getFile("webby.json").then(data => {
            let webby = JSON.parse(data) || [];
            if (process.env.DEV) console.log("searches loaded: ", webby);
            this.initializeFromGaia(webby);
          });

          this.$router.push("/webby");
        }
      };

      showBlockstackConnect(authOptions);
    },
    async signOut() {
      const update = {
        id: "",
        name: "",
        avatar: "",
        authenticated: false
      };
      await this.setUser(update);
      userSession.signUserOut("/");
    }
  }
};
</script>

<style>
input:focus {
  outline: none;
}
.searchbox {
  border: 0px;
  border-radius: 8px;
  padding-left: 10px;
  padding-right: 10px;
  padding-top: 4px;
  padding-bottom: 4px;
  background-color: rgba(255, 255, 255, 0.5);
  height: 40x;
  flex-direction: row;
  min-width: 300px;
  display: flex;
  justify-content: space-between;
}
.search-icon {
  margin-right: 7px;
  padding-top: 3px;
}
input[type="search"] {
  background: transparent;
  border: none;
}

input[type="search"]::-webkit-search-cancel-button {
  -webkit-appearance: searchfield-cancel-button;
}

.avatar-right-margin {
  margin-right: 8px;
}
</style>
